<?php
/*  class.antispam.php
Software: AntiSpam - PHP form class
Version:	1.0 Beta
Copyright (c) 2011, Peter Junk. All Rights Reserved. 
Das Script darf frei verwendet werden solange
der Copyright-Vermerk bestehen bleibt.
*/
class AntiSpam {
  //max. Zeit fuer Formular 20min = 1200s
	public $maxformtime = 1200; //max Zeit fr Alter 
	public $minformtime = 10;  //Sek.
	public $maxIPs = 5;  //max. Anzahl von selber IP
	//1 zhlt nur mit noch gltigen , 2 zhlt nur mit  verbrauchten TAN, 3 alle
	public $IpcountMode = 2;  
	public $GroupName = "";
	public $spamtyp = 0;
	public $javascriptcode = "";
	public $useJS = false;
	public $liveTime = 3600;  //1h, auch Zeit fr IP-Sperre
	public $NamejsFunction = "pj_antispam_mcr";
	//
	private $blank = true;
	private $jsactiv = false;
	private $lastTAN = 0;
	private $IPc = 0;
	private $filename = "";
	//Return TAN > 0 ok oder false wenn Spam
	//1.Pflichtparameter: Name des Post-Feldes mit der TAN-Nr.
	//2.Opt.Parameter: true, wenn TAN gueltig bleiben soll und nicht als verbraucht gekennzeichnet werden soll
	public function GetTAN ($tannamepost,$nodel = false) {
		$tannr = false;
		//TAN-Datei lesen
		$dname = ($this -> GroupName == "") ? $tannamepost : $this -> GroupName ;
		$this -> filename = $dname.".dat" ;
		$datei = @file_get_contents($this -> filename); 
	  $dids = $datei === false ? array() : json_decode($datei);
		//Alter der TANs prfen
		$ids = array();
		for($i = 0; $i < count($dids); $i++) {
			if( time() <= $dids[$i] -> Time + $this -> liveTime ) $ids[] = $dids[$i]; //erhalten
		}
		//Formular ausgefuellt ?
		if(isset($_POST[$tannamepost])) {
			$this -> blank = false;
			//Formular mit Eintraegen gesendet
			$ident = $_POST[$tannamepost];
			//ident ist gltige TAN ?
			$aindex=false;
			$this -> jsactiv = false;
			for($i = 0; $i < count($ids); $i++) {
				if($ids[$i] -> ID == $ident && !$this -> useJS) $aindex=$i;
				if($ids[$i] -> ID2 == $ident) {
					$aindex=$i;
					$this -> jsactiv = true;
					$this -> javascriptcode = $ids[$i] -> JS;
					$ident = $ids[$i] -> ID;
				}
			}
			if($aindex !== false) {
				//ID vorhanden
				$this -> lastTAN = $ident;
				$IDtime = $ids[$aindex] -> Time;
				//IP Zugriffe zhlen
				$IP = $ids[$aindex] -> IP;
				$IPcount = 0;
				for($i = 0; $i < count($ids); $i++) {
					if($IP == $ids[$i] -> IP) {
						if( $ids[$i] -> TANvalid && $this -> IpcountMode & 1) ++$IPcount;
						if( ! $ids[$i] -> TANvalid && $this -> IpcountMode & 2) ++$IPcount;
					}
				}
				$this -> IPc = $IPcount;
				//
				if( $ids[$aindex] -> TANvalid ) {
					//TAN ist gueltig
					if( time() < $IDtime + $this -> minformtime ) { 
						$this -> spamtyp = 2; // minformtime
					}
					elseif ( time() > $IDtime + $this -> maxformtime ) { 
						$this -> spamtyp = 3; // maxformtime
					}
					else {
						//Schon mehrere gefllte Formulare von der selben IP empfangen ?
						if($IPcount >= $this -> maxIPs) {
							$this -> spamtyp = 4; //maxIPs Formulars
						}
						else {
							//Ok
							$tannr = $ident;
							$this -> spamtyp = 0;
						}
					}
				}
				else $this -> spamtyp = 1; //Invalid TAN;
				//Index als ungueltig markieren
				if(!$nodel) $ids[$aindex] -> TANvalid = false;
			}
			else {
				//ID ungueltig oder bereits gelscht
				$this -> spamtyp = "Invalid TAN";
			}
		}
		else {
			//Formular neu angefordert
			$this -> blank = true;
			$this -> spamtyp = "";
			//ident erzeugen
			$ident = rand ( 1,99999 );
			$this -> lastTAN = $ident;
			//js erzeugen
			$ID2 = $this -> GetJsId($ident,$tannamepost);
			//ident speichern
			$ids[] = array(
				'ID' => $ident,
				'TANvalid' => true,
				'IP' => $_SERVER['REMOTE_ADDR'],
				'Time' => time(),
				'ID2' => $ID2,
				'JS' => $this -> javascriptcode
			);
			$tannr = $ident;
		}
	file_put_contents($this -> filename,json_encode($ids));
	return $tannr;
	}
	//Mit Parameter > 0 wird tan gesucht, sonst $this -> lastTAN
	public function SetTANvalid($tan=0) {
		if($tan==0) $tan = $this -> lastTAN;
		if($tan != 0 && $this -> filename != "") {
			//TAN-Datei lesen
			$datei = @file_get_contents($this -> filename); 
			$ids = $datei === false ? array() : json_decode($datei);
			for($i = 0; $i < count($ids); $i++) {
				if(($ids[$i] -> ID == $tan) || ($ids[$i] -> ID2 == $tan)) $ids[$i] -> TANvalid = true;
			}
			file_put_contents($this -> filename,json_encode($ids));
		}
	}
	//Liefert Info ob JS auf dem Client aktiv ist nach Aufruf von GetTAN
	public function isJSaktiv() {
		return $this -> jsactiv;
	}
	//Liefert Info ob das Hidden-Formularfeld gefuellt ist
	public function isFormFilled() {
		return ! $this -> blank;
	}
	//Liefert die Anzahl der Zugriffe von der akt. IP
	public function getIPcount() {
		return $this -> IPc;
	}
	//Liefert Beschreibung zum Spamtyp
	public function getSpamDescription() {
	  $desc = array(
			"No Spam",
			"Invalid TAN",
			"Time < ".$this -> minformtime." Sekunden",
			"Time > ".$this -> maxformtime." Sekunden",
			"More as ".$this -> maxIPs." Formulars"
			);
		return $desc[$this -> spamtyp];
	}
	
	//internal
	private function GetJsId($ident, $tannamepost) {
		$js = '<script type="text/javascript">'."\r\nfunction ".$this -> NamejsFunction."() {\r\n";
		$js .= 'var eltan = document.getElementsByName("'.$tannamepost.'")[0];'."\r\n";
		$rd = rand (100,999);
		$js .= 'var tan = eltan.value * 1 + '.$rd.";\r\n";
		$ID2 = $ident + $rd;
		$js .= "eltan.value = tan;\r\n } \r\n</script>\r\n";
		$this -> javascriptcode = $js;
		return $ID2;
	}
}
?>
